# Integration

In this section you find everything to know, how to integrate our configurator into an existing website.

You will learn what events in Rubens are and when they are fired, so you can:

* Listen to the request product button
* How to react on parts list changes
* Listen to analytic events
* Overriding buttons
* ... everything you want to do with our events

Moreover, you will be able to use our java script api function and can add custom elements on the top of our UI:

* Implement you own custom buttons
* Trigger 3D scene functions
* Change parameter code wise
* ... everything you can do with our variaty of api functions

### Code Sandbox

If you want to have just a quick look or want to copy paste an example, you can have a look in this sample [Code Sandbox.](https://codesandbox.io/p/sandbox/trigger-request-product-forked-8nn8s3)

### Helpful links

Rubens UI Events: [ExposedCallbacks.ExposedCallbacks](/rubens/rubens-products/rubens-products-reference/classes/exposed_callbacks.exposedcallbacks.md)\
Rubens SDK Events: [ServicesConfiguratorUiCallback.default](/rubens/rubens-sdk/rubens-sdk-reference/classes/configurator_core_src_services_configurator_ui_callback.default.md)

Rubens UI API functions: [ExposedApi.ExposedApi](/rubens/rubens-products/rubens-products-reference/classes/exposed_api.exposedapi.md)\
Rubens SDK API functions: [RoomleConfigurator.default](/rubens/rubens-sdk/rubens-sdk-reference/classes/configurator_core_src_roomle_configurator.default.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.roomle.com/rubens/rubens-products/rubens-configurator/integration.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
